;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of AMSTRON: An Amstrad CPC Game 
;;  Copyright (C) 2019 - CPC Games 'La Yema' Francisco Luis Fernández Soriano
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "header.h.s"
.include "entity_manager.h.s"
 

player1_left: .dw #Key_CursorLeft
player1_right: .dw #Key_CursorRight
player2_left: .dw #Key_O
player2_right: .dw #Key_P

key_to_ckeck_left: .dw #Key_CursorLeft 
key_to_ckeck_right: .dw #Key_CursorRight


red_robot_arena_7: .db #0x00



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_switch_arena
;;  
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


input_system_switch_arena:

loop_input_system_switch_arena:
     ; scan the whole keyboard
    call cpct_scanKeyboard_asm
    ld hl, #Key_1
    call cpct_isKeyPressed_asm
    jp nz, assign_arena1_to_versus_mode
    ld hl, #Key_2
    call cpct_isKeyPressed_asm
    jp nz, assign_arena2_to_versus_mode
    ld hl, #Key_3
    call cpct_isKeyPressed_asm
    jp nz, assign_arena3_to_versus_mode
    ld hl, #Key_4
    call cpct_isKeyPressed_asm
    jp nz, assign_arena4_to_versus_mode
    ld hl, #Key_5
    call cpct_isKeyPressed_asm
    jp nz, assign_arena5_to_versus_mode
    ld hl, #Key_6
    call cpct_isKeyPressed_asm
    jp nz, assign_arena6_to_versus_mode
    ld hl, #Key_7
    call cpct_isKeyPressed_asm
    jr nz, assign_arena7_to_versus_mode
    ld hl, #Key_8
    call cpct_isKeyPressed_asm
    jp nz, assign_arena8_to_versus_mode
    ld hl, #Key_9
    call cpct_isKeyPressed_asm
    jp nz, assign_arena9_to_versus_mode
    jp loop_input_system_switch_arena

assign_arena1_to_versus_mode:
    ld a, #ARENA_1
    ld ( _arena ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena2_to_versus_mode:
    ld a, #ARENA_2
    ld ( _arena ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena3_to_versus_mode:
    ld a, #ARENA_3
    ld ( _arena ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena4_to_versus_mode:
    ld a, #ARENA_4
    ld ( _arena ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena5_to_versus_mode:
    ld a, #ARENA_5
    ld ( _arena ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena6_to_versus_mode:
    ld a, #ARENA_6
    ld ( _arena ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena7_to_versus_mode:
    ld a, #ARENA_7
    ld ( _arena ), a
    ld a, #0x01
    ld ( _red_robot ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena8_to_versus_mode:
    ld a, #ARENA_8
    ld ( _arena ), a
    ld a, #0x01
    ld ( _red_robot ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret
assign_arena9_to_versus_mode:
    ld a, #ARENA_9
    ld ( _arena ), a
    ld a, #0x01
    ld ( _red_robot ), a
    ld a, #0x00
    ld ( #_not_music ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_redefine_keys
;;  
;;  INPUT -> HL ( Key )
;;  
;;  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


input_system_shearch_key_press_by_player:
    push hl
input_system_switch_arenaloop_p1_left:
     ; scan the whole keyboard
    call cpct_scanKeyboard_asm
    ;; If no key is pressed, the address is read and incremented
    call cpct_isAnyKeyPressed_asm
    jr z, input_system_switch_arenaloop_p1_left
    jr p1_left_assig
p1_left_assig:
    ld de, #0x0100
assign_player1_left:
    ld h, d
    ld l, e
    push de
    call cpct_isKeyPressed_asm
    pop de
    jp nz, assign_p1_left
    inc e
    ld a, e
    cp #0x0A
    jr z, rlc_d
    jp assign_player1_left
rlc_d:
    ld e, #0x00
    ld a, d
    add d
    ld d, a 
    jp assign_player1_left
assign_p1_left:
    
    pop hl
    ld ( hl ),e
    inc hl
    ld ( hl ), d


ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_redefine_keys
;;  
;;  
;;  
;;  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


input_system_redefine_keys:
    call clearScreen
    call render_sky_stars

  
    ;;call render_system_top_menu
    ld a, #P1_RIGHT
    call render_system_redefine_keys
    ld hl, #player1_right
    call input_system_shearch_key_press_by_player

    call render_sky_stars
    call clearScreen
    call render_sky_stars
    ;;call render_system_top_menu
    ld a, #P1_LEFT
    call render_system_redefine_keys
    ld hl, #player1_left
    call input_system_shearch_key_press_by_player

    call clearScreen
    call render_sky_stars
    ;;call render_system_top_menu
    ld a, #P2_LEFT
    call render_system_redefine_keys
    ld hl, #player2_right
    call input_system_shearch_key_press_by_player

    call clearScreen
    call render_sky_stars
    ;;call render_system_top_menu
    ld a, #P2_RIGHT
    call render_system_redefine_keys
    ld hl, #player2_left
    call input_system_shearch_key_press_by_player

ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_menu
;;  
;;  
;;  
;;  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

input_system_menu:
 
loop_system_menu:

    call collision_clean_all_matrix
    ; scan the whole keyboard
    call cpct_scanKeyboard_asm
    ;; If no key is pressed, the address is read and incremented
    ld hl, #Key_4
    call cpct_isKeyPressed_asm
    jr nz,  option4
    ld hl, #Key_3
    call cpct_isKeyPressed_asm
    jr nz,  option3
    ld hl, #Key_1
    call cpct_isKeyPressed_asm
    jr nz,  option1
    ld hl, #Key_2
    call cpct_isKeyPressed_asm
    jr nz,  option2
    jr loop_system_menu
ret
option4: 
    ;;call render_animation_carrera_mode_1
    ld c, #1
    call cpct_setVideoMode_asm
    ld hl, #_g_palette
    ld de, #04
    call cpct_setPalette_asm
   call render_system_credit_screen
ret

option3: 
    ;;call render_animation_carrera_mode_1
    ld c, #1
    call cpct_setVideoMode_asm
    ld hl, #_g_palette
    ld de, #04
    call cpct_setPalette_asm
    call input_system_redefine_keys
    ld c, #0
    call cpct_setVideoMode_asm
    ld hl, #_g_palette_2
   ld de, #16
   call cpct_setPalette_asm 
ret
option1:
    ld a, #0x01
    ld ( #_not_music ), a
    call cpct_akp_stop_asm
    ;;call render_animation_carrera_mode_1
    ld c, #1
    call cpct_setVideoMode_asm
    ld hl, #_g_palette
    ld de, #04
    call cpct_setPalette_asm
    call render_system_animation_begin
;;loop_input_pause_option_1:
    ;; scan the whole keyboard
    ;;call cpct_scanKeyboard_asm
    ;; If no key is pressed, the address is read and incremented
    ;;ld hl, #Key_L
    ;;call cpct_isKeyPressed_asm
    ;;cp #0
    ;;jr nz,  input_pause_continuos_option_1
    ;;jp loop_input_pause_option_1 

;;input_pause_continuos_option_1:
    ld a, #NOT_GAME_OVER
    ld ( #_game_over ), a
    ld a, #CARRERA_MODE
    ld ( #_game_mode ), a
    ld  de, #_song_game
    call cpct_akp_musicInit_asm
    ld a, #0x00
    ld ( #_not_music ), a
    
ret
option2: 
    
    ld a, #0x01
    ld ( #_not_music ), a
    call cpct_akp_stop_asm
    ld c, #1
    call cpct_setVideoMode_asm
    ld hl, #_g_palette
    ld de, #04
    call cpct_setPalette_asm
    ld a, #VERSUS_MODE
    ld ( #_game_mode ), a
    ld a, #NOT_GAME_OVER
    ld ( #_game_over ), a
    call render_system_switch_arena
    call input_system_switch_arena

ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_pause
;;  
;;  INPUT HL --> Pointer to Matrix
;;  INPUT B -> Coord. X in Screenc_div_d
;;  INPUT C -> Coord. Y in Screen  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
input_game_over:

    call render_game_over  

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_pause
;;  
;;  INPUT HL --> Pointer to Matrix
;;  INPUT B -> Coord. X in Screenc_div_d
;;  INPUT C -> Coord. Y in Screen  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
input_pause::

    ld a, e_lives(ix)
    cp #NUM_LIVES
    jr z, continue_to_input_pause

    ld bc, #sizeof_e
    add ix, bc


continue_to_input_pause:
      call collision_clean_all_matrix
    ld a, #PAUSE
    ld ( #_pause_level ), a
    call render_rectangle_pause
    ld a, ( #_game_mode )
    cp #CARRERA_MODE
    jr z, input_pause_carrera_mode
    jr input_pause_game_over


input_pause_carrera_mode:
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, input_pause_game_over
    jr input_next_level_or_p1_win

input_pause_game_over:

    call render_game_over
    ld a, #GAME_OVER
    ld ( #_game_over), a
     ld a, #ARENA_1
    ld ( #_arena ), a
    ld a, #0x00
    ld ( #_red_robot), a

    jr loop_input_pause
    
    
input_next_level_or_p1_win:
    ld a, ( #_arena )
    cp #LAST_ARENA
    jr z, input_pause_game_over
    inc a
    ld ( #_arena ), a
    cp #ARENA_7
    jr z, add_robot_to_ia
    cp #ARENA_8
    jr z, add_robot_to_ia
    cp #ARENA_9
    jr z, add_robot_to_ia
    jr continue_call_render_next_level
add_robot_to_ia:
    ld a, #0x01
    ld ( #_red_robot), a

continue_call_render_next_level:
    call render_next_level


loop_input_pause:
    ;; scan the whole keyboard
    call cpct_scanKeyboard_asm
    ;; If no key is pressed, the address is read and incremented
    ld hl, #Key_C
    call cpct_isKeyPressed_asm
    cp #0
    jr nz,  input_pause_continuos 
    jp loop_input_pause    

input_pause_continuos:
    ld a, ( #_game_over )
    cp #GAME_OVER
    ret z
    call input_system_init

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_get_position_in_matrix
;;  
;;  INPUT HL --> Pointer to Matrix
;;  INPUT B -> Coord. X in Screenc_div_d
;;  INPUT C -> Coord. Y in Screen  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
input_entity_reset::



        ld a, e_player(ix)
        cp #PLAYER1
        jr z, input_entity_p1_reset
        cp #PLAYER2
        jr z, input_entity_p2_reset
        cp #ROBOT
        jp z, input_entity_robot_reset

        
input_entity_p2_reset:
        ld e_x(ix), #0x44
        ld e_y(ix), #0xB0
        ld e_ma_x(ix), #0x48
        ld e_ma_y(ix), #0xB0
        ld e_w(ix), #0x04 
        ld e_h(ix), #0x04  
        ld hl, #_mrl
        ld e_sp_l(ix), l
        ld e_sp_h(ix), h
        ld e_dir(ix), #MOTORBIKE_DIR_LEFT
        ld e_dir_ant(ix), #MOTORBIKE_DIR_LEFT
        ld e_ma_x(ix), #0x48
        ld e_ma_y(ix), #0xB0
        ld e_changedir(ix), #MOTORBIKE_NOT_CHANGE_DIRECTION
        ld e_keypress(ix) , #NOTHING
        ld e_hv(ix), #MOTORBIKE_HORIZONTAL
        ld e_num_mov(ix), #0
        ld e_collision(ix), #MOTORBIKE_NO_COLLISION
        ld e_reset(ix), #NO_RESET_PLAYER 
        ld e_extra_turn_right(ix), #0x00 
        ld e_extra_turn_down(ix), #0x00  
        ld e_anim(ix), #0x00

ret
input_entity_p1_reset:
        ld e_x(ix), #0x08
        ld e_y(ix), #0x30
        ld e_w(ix), #0x04 
        ld e_h(ix), #0x04  
        ld hl, #_mvr
        ld e_sp_l(ix), l
        ld e_sp_h(ix), h
        ld e_sp_ant_l(ix), l
        ld e_sp_ant_h(ix), h  
        ld e_dir(ix), #MOTORBIKE_DIR_RIGHT
         ld e_dir_ant(ix), #MOTORBIKE_DIR_LEFT
        ld e_ma_x(ix), #0x04
        ld e_ma_y(ix), #0x30
        ld e_changedir(ix), #MOTORBIKE_NOT_CHANGE_DIRECTION
        ld e_keypress(ix) , #NOTHING
        ld e_hv(ix), #MOTORBIKE_HORIZONTAL
        ld e_num_mov(ix), #0
        ld e_collision(ix), #MOTORBIKE_NO_COLLISION
        ld e_reset(ix), #NO_RESET_PLAYER 
        ld e_extra_turn_right(ix), #0x00 
        ld e_extra_turn_down(ix), #0x00  
        ld e_anim(ix), #0x00


       
ret
input_entity_robot_reset:

        ld e_x(ix), #0x30
        ld e_y(ix), #0x60
        ld e_w(ix), #0x04 
        ld e_h(ix), #0x10  
        ld hl, #_robot 
        ld e_sp_l(ix), l
        ld e_sp_h(ix), h
        ld e_sp_ant_l(ix), l
        ld e_sp_ant_h(ix), h  
        ld e_dir(ix), #MOTORBIKE_DIR_LEFT
        ld e_dir_ant(ix), #MOTORBIKE_DIR_LEFT
        ld e_ma_x(ix), #0x30
        ld e_ma_y(ix), #0x60
        ld e_changedir(ix), #MOTORBIKE_NOT_CHANGE_DIRECTION
        ld e_keypress(ix) , #NOTHING
        ld e_hv(ix), #MOTORBIKE_HORIZONTAL
        ld e_num_mov(ix), #0
        ld e_collision(ix), #MOTORBIKE_NO_COLLISION
        ld e_reset(ix), #NO_RESET_PLAYER 
        ld e_extra_turn_right(ix), #0x00 
        ld e_extra_turn_down(ix), #0x00  
        ld e_anim(ix), #0x00
        

ret   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_robot
;;  
;;  
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

input_system_robot:
    ld a, ( _arena )
    cp #ARENA_4
    jr z, red_robot_arena_4
    jr no_red_robot

red_robot_arena_4:
    ld a, #ROBOT
    ld ( _ia_robot ), a

no_red_robot:

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_init
;;  
;;  
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
input_system_init::

    call entityman_getEntityArray_IX
    call entityman_getNumEntities_A
 
_renloop_input_system_init:

    push af

    ld a, e_player(ix)

    ;;call input_system_robot


    call input_entity_reset
    ld e_lives(ix), #0x0A
    ld e_num_mov(ix), #0x00
    ld e_collision(ix), #MOTORBIKE_NO_COLLISION

    

    ld a, e_player(ix)
    cp #ROBOT
    jr z, continue_input_system_init

    ld a, e_player(ix)
    cp #PLAYER1
    jr z, continue_input_system_init
    ld a, ( _game_mode )
    cp #VERSUS_MODE
    jr z, e_player_player2
    ld e_player(ix), #IA

    jr continue_input_system_init 
 
e_player_player2:
    ld e_player(ix), #PLAYER2

    
continue_input_system_init:  
    pop af

    dec a
    jr z, input_system_init_render ;; Equals to JZ  

    ld bc, #sizeof_e
    add ix, bc
    jp _renloop_input_system_init

input_system_init_render:

    call render_system_init 

  

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_get_position_in_matrix
;;  
;;  INPUT HL --> Pointer to Matrix
;;  INPUT B -> Coord. X in Screenc_div_d
;;  INPUT C -> Coord. Y in Screen  
;;  
;;  OUTPUT -> HL --> Pointer to Matrix
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

input_get_position_in_matrix::
    ;;motorbike_horizontal:
    ld a, c
    sub #0x28
    ld c,a
    ;; Divide C to 8px
    ;;;;;;;;;;;;;;;;;;;;;;;;;,
    ld a, c
    ld e, #0x00
loop_divide_8:
    sub #0x08
    inc e
    ld c,a
    cp #0x00
    jr z,calculate_x
    jr loop_divide_8
calculate_x:
    ld c, e
    ;; Divide B to 4 px
    sra b
    sra b 
    ld a,c
loop_y:
    cp #0x00
    jr z, go_to_x
    ld de, #0x0014
    add hl, de
    dec a
    jr loop_y
go_to_x:
    ld e, b
    ld d, #0x00
    add hl, de
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_assign_values
;;  Modify X,Y, MX, MY in function of the Direction of Motorbike
;;  INPUT A-> Direction, IX ENTITY VECTOR 
;;  
;;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
input_assign_values:
    
    cp #MOTORBIKE_DIR_RIGHT
    jr z, increase_x
    cp #MOTORBIKE_DIR_LEFT
    jr z, decrement_x
    cp #MOTORBIKE_DIR_UP
    jr z, decrement_y
    ld a, e_y(ix)
    add #0x10
    ld e_y(ix),a
ret
increase_x: 
    ld a, e_x(ix)
    add #0x04
    ld e_x(ix),a
ret
decrement_x: 
    ld a, e_x(ix)
    sub #0x04
    ld e_x(ix),a
ret
decrement_y:
    ld a, e_y(ix)
    sub #0x10  
    ld e_y(ix),a
ret
    
ret

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_calculate_update
;;  Modify X,Y, MX, MY in function of the Direction of Motorbike
;;  INPUT A-> Direction, IX ENTITY VECTOR 
;;  
;;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

input_calculate_update:

    ld e_changedir(ix), #MOTORBIKE_CHANGE_DIRECTION
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_RIGHT
    jr z, direction_right
    cp #MOTORBIKE_DIR_DOWN
    jr z, direction_down
    cp #MOTORBIKE_DIR_LEFT
    jr z, direction_left
    jp direction_up
direction_up:
    ld a, e_keypress(ix)
    cp #KEY_PRESS_RIGHT
    jp z, turn_right
    jr turn_left
direction_down:
    ld a, e_keypress(ix)
    cp #KEY_PRESS_RIGHT
    jr z, turn_left
    jp turn_right
direction_right:    
    ld a, e_keypress(ix)
    cp #KEY_PRESS_RIGHT
    jp z, turn_down
    jp turn_up
direction_left:
    ld a, e_keypress(ix)
    cp #KEY_PRESS_RIGHT
    jp z, turn_up
    jr turn_down
turn_left:
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, sprite_left_p1
    ld hl, #_mrl
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h
    jr continous_turn_left
sprite_left_p1:
    ld hl, #_mvl
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h  
continous_turn_left:
    ld e_w(ix), #0x04
    ld e_h(ix), #0x04
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_DOWN
    jr z, continous_turn_left_down
    ld e_dir(ix), #MOTORBIKE_DIR_LEFT
    ld e_hv(ix), #MOTORBIKE_HORIZONTAL
    ld a,e_x(ix)
    sub #0x04
    ld e_x(ix), a
ret
continous_turn_left_down:
    ld e_dir(ix), #MOTORBIKE_DIR_LEFT
    ld e_hv(ix), #MOTORBIKE_HORIZONTAL
    ld a,e_x(ix)
    sub #0x04
    ld e_x(ix), a
    ld a,e_y(ix)
    add #0x10
    ld e_y(ix), a
    ld a, e_x(ix)
    add #0x04
    ld b, a
    ld c, e_y(ix)
    ld hl, #_matrix 
    call input_get_position_in_matrix
    ld a, e_player(ix)
    ld (hl), a  
ret
turn_down:

    ld a, e_player(ix)
    cp #PLAYER1
    jr z, sprite_down_p1
    ld hl, #_mrd
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h
    jr continous_turn_down
sprite_down_p1:
    ld hl, #_mvd
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h   
continous_turn_down:
    ld e_w(ix), #0x01
    ld e_h(ix), #0x10
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_RIGHT
    jr z, continous_turn_down_right
    ld e_dir(ix), #MOTORBIKE_DIR_DOWN
    ld e_hv(ix), #MOTORBIKE_VERTICAL  
ret
continous_turn_down_right:
    ld e_dir(ix), #MOTORBIKE_DIR_DOWN
    ld a,e_anim(ix)
    
    ld a,e_x(ix)
    add #0x04
    ld e_x(ix), a
ret
turn_up:

    ld a, e_player(ix)
    cp #PLAYER1
    jr z, sprite_up_p1
    ld hl, #_mru
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h
    jr continous_turn_up
sprite_up_p1:
    ld hl, #_mvu
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h
continous_turn_up:
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_LEFT
    jr z, continous_turn_up_left
    ld a,e_x(ix)
    add #0x04
    ld e_x(ix), a
    ld a,e_y(ix)
    sub #0x10
    ld e_y(ix), a
    ld e_w(ix), #0x01
    ld e_h(ix), #0x10
    ld e_dir(ix), #MOTORBIKE_DIR_UP
    ld e_hv(ix), #MOTORBIKE_VERTICAL
    ld a, e_ma_x(ix)
    add #0x04
    ld b, a
    ld c, e_ma_y(ix)
    ld hl, #_matrix 
    call input_get_position_in_matrix
    ld a, e_player(ix)
    ld (hl), a
ret
continous_turn_up_left:

    ld a,e_y(ix)
    sub #0x10
    ld e_y(ix), a
    ld e_w(ix), #0x01
    ld e_h(ix), #0x10
    ld e_dir(ix), #MOTORBIKE_DIR_UP
    ld e_hv(ix), #MOTORBIKE_VERTICAL
ret
turn_right:
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, sprite_right_p1
    ld hl, #_mrr
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h
    jr continous_turn_right
sprite_right_p1:
    ld hl, #_mvr
    ld e_sp_l(ix), l
    ld e_sp_h(ix), h
continous_turn_right:
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_UP
    jr z, continous_turn_right_up
    ld e_dir(ix), #MOTORBIKE_DIR_RIGHT
    ld e_hv(ix), #MOTORBIKE_HORIZONTAL
    ld e_w(ix), #0x04
    ld e_h(ix), #0x04
    ld a,e_y(ix)
    add #0x10
    ld e_y(ix), a
ret
continous_turn_right_up:
    ld e_dir(ix), #MOTORBIKE_DIR_RIGHT
    ld e_hv(ix), #MOTORBIKE_HORIZONTAL
    ld e_w(ix), #0x04
    ld e_h(ix), #0x04    
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_store_mov_in_matrix
;;
;;  
;;  INPUT B -> X Coord.
;;  INPUT C -> Y Coord. ;; 
;;  
;;  
;;  
;;  Store in Position X,Y of matrix Mov.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

input_store_mov_in_matrix::
    call input_get_position_in_matrix
    ld a, (hl)
    cp #WALL
    jr z, not_store_player_mov_in_matrix
    ld a, e_player(ix)
    ld (hl), a 
    ld a, e_dir(ix)
not_store_player_mov_in_matrix:
    cp #MOTORBIKE_DIR_UP
    jr z, input_store_mov_in_matrix_decrement_y
    cp #MOTORBIKE_DIR_DOWN
    jr z, input_store_mov_in_matrix_decrement_y
    ld a, e_player(ix)
    cp #ROBOT
    jr z, input_store_mov_in_matrix_decrement_y
ret
input_store_mov_in_matrix_decrement_y:
    ld de, #0x0014
    ld a, (hl)
    cp #WALL
    ret z
    add hl, de
    ld a, e_player(ix)
    ld (hl), a  
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_calculate_direction_ia
;;  Modify X,Y, MX, MY in function of the Direction of Motorbike
;;  INPUT A-> Direction, IX ENTITY VECTOR 
;;  
;;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
input_calculate_direction_ia:
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_LEFT
    jr z, input_check_2_x_left
    cp #MOTORBIKE_DIR_UP
    jr z, input_check_2_y_up
    cp #MOTORBIKE_DIR_RIGHT
    jr z, input_check_2_x_right
    ld a, e_y(ix)
    add #0x20
    ld b, e_x(ix)
    ld c, a
    jr input_check_new_value

input_check_2_x_left:
    ld a, e_x(ix)
    sub #0x08
    ld b, a
    ld c, e_y(ix)
    jr input_check_new_value
input_check_2_y_up:
    ld a, e_y(ix)
    sub #0x20
    ld b, e_x(ix)
    ld c, a
    jr input_check_new_value
input_check_2_x_right:
    ld a, e_x(ix)
    add #0x08
    cp #LIMIT_X_RIGHT-4
    jr z, turn
    ld b, a
    ld c, e_y(ix)
    jr input_check_new_value
input_check_new_value:
    ld a, b
    cp #LIMIT_X_LEFT
    jr z, turn
    ld hl, #_matrix
    call input_get_position_in_matrix 
    ld e, #NO_TURN
    ld a, (hl)
    cp #0xFF
    jp z, no_turn
    ld e, #TURN
no_turn:
ret
turn:
   ld e, #TURN 
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_update
;;  Modify X,Y, MX, MY in function of the Direction of Motorbike
;;  INPUT A-> Direction, IX ENTITY VECTOR 
;;  
;;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

input_move_robot:

  call input_calculate_direction_ia
  ld a,e
  cp #NO_TURN
  jr z, no_ia_turn
  jr change_dir_ia
no_ia_turn:
    ld a, e_dir(ix)
    call input_assign_values
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_DOWN
    jr z, change_ia_direction_down
    
ret
change_ia_direction_down:
    ld e_dir(ix), #MOTORBIKE_DIR_RIGHT
ret
change_dir_ia:
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_LEFT
    jr z, change_dir_ia_left
    cp #MOTORBIKE_DIR_UP
    jr z, change_dir_ia_up
    cp #MOTORBIKE_DIR_RIGHT
    jr z, change_dir_ia_right
    ld e_dir(ix), #MOTORBIKE_DIR_RIGHT
ret
change_dir_ia_left:
    ld e_dir(ix), #MOTORBIKE_DIR_DOWN
ret
change_dir_ia_up:
    ld e_dir(ix), #MOTORBIKE_DIR_LEFT
ret
change_dir_ia_right:
    ld e_dir(ix), #MOTORBIKE_DIR_UP
ret

    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  input_system_update
;;  Modify X,Y, MX, MY in function of the Direction of Motorbike
;;  INPUT A-> Direction, IX ENTITY VECTOR 
;;  
;;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


input_system_update::

    ld a, ( #_pause_level )
    cp #PAUSE
    jp z, no_input_system_update
    ld a, ( _iterations )
    cp #0x0A
    jr z, restart_iterations
    jr continue_input_system_update
restart_iterations:
    ld a, #0x00
    ld ( _iterations ),a


continue_input_system_update:

    inc a
    ld ( _iterations ),a

  call entityman_getEntityArray_IX
  call entityman_getNumEntities_A

_renloop:
    push af
    
    ld a, e_collision(ix)
    cp #0x01
    jp z, is_ia

    ld a, e_player(ix)
    cp #ROBOT
    jr z, check_arena
    jp continue_without_check
check_arena:
    ld a, ( _arena )
    cp #ARENA_1
    jp z,is_ia
    cp #ARENA_2
    jp z,is_ia
    cp #ARENA_3
    jp z,is_ia
    cp #ARENA_4
    jp z,is_ia
    cp #ARENA_5
    jp z,is_ia
    cp #ARENA_6
    jp z,is_ia
    ld a, #0x01
    ld ( #_red_robot ), a
    
continue_without_check:
    ld a, e_num_mov(ix)
    cp #0x00
    jp z, store_first_mov

    
    

    ;;
    ;; Save the ant state
    ld a, e_y(ix)
    ld e_ma_y(ix),a
    ld a, e_x(ix)
    ld e_ma_x(ix),a
    ld a, e_dir(ix)
    ld e_dir_ant(ix), a
    ld a, e_sp_l(ix)
    ld e_sp_ant_l(ix), a
    ld a, e_sp_h(ix)
    ld e_sp_ant_h(ix), a
    ld a, e_w(ix)
    ld e_w_ant(ix), a
    ld a, e_h(ix)
    ld e_h_ant(ix), a
    
    ld a, e_player(ix)
    cp #ROBOT
    jp z, call_input_move_robot
    
    ;;Comprobacion de que es el player
    ld a, e_player(ix)
    cp #IA
    jp z, artifical_intelligence
    cp #PLAYER1
    jp z, key_p1
    ;; player2 code
    ld de , ( player2_left )
    ld (key_to_ckeck_left), de
    ld de, ( player2_right )
    ld (key_to_ckeck_right), de
    jr check_key_press
key_p1:
    ld de, ( player1_left )
    ld (key_to_ckeck_left), de
    ld de, ( player1_right )
    ld ( key_to_ckeck_right ), de
check_key_press:
    ;; scan the whole keyboard
    call cpct_scanKeyboard_asm
    ;; If no key is pressed, the address is read and incremented
    ld hl, (key_to_ckeck_left)
    call cpct_isKeyPressed_asm
    cp #0               
    jr nz, key_left_pressed
    ld hl, (key_to_ckeck_right)
    call cpct_isKeyPressed_asm
    cp #0               
    jr nz, key_right_pressed
    ;; Set nothing pulse key
nothing_key_pressed:
    ld e_keypress(ix), #NOTHING
    ld a, e_dir(ix)
    call input_assign_values
    jp is_ia

key_left_pressed:
     ld a, e_y(ix)
     cp #0x030
     jr z, nothing_key_pressed
     cp #0xB0
     jr z, nothing_key_pressed    
     ld e_keypress(ix), #KEY_PRESS_LEFT 
     call input_calculate_update
     jp is_ia
     
key_right_pressed:
     ld e_keypress(ix), #KEY_PRESS_RIGHT
     call input_calculate_update
     jr is_ia

artifical_intelligence:
    call input_calculate_direction_ia
  
    ld a, e
    cp #NO_TURN
    jr z, ia_input_assign_values
    jr turn_input_assign_values
ia_input_assign_values:
    ld a, e_dir(ix)
    call input_assign_values
    jr is_ia
turn_input_assign_values:
    ld a, e_lives(ix)
    ld b, #5
    jp nc, ia_turn_right
    jr ia_turn_left
ia_turn_right:
    ld e_keypress(ix), #KEY_PRESS_RIGHT 
    jr continue_ia_calculate_update
ia_turn_left:
    ld e_keypress(ix), #KEY_PRESS_LEFT
continue_ia_calculate_update:
    call input_calculate_update
    jr is_ia

call_input_move_robot:
    ld a, ( #_red_robot )
    cp #0x00
    jr z, is_ia
    ld a, ( _iterations )
    cp #0x05
    jr z, move_robot
    jr is_ia
move_robot:
    ld a, e_x(ix)
    ld b, e_y(ix)
    call input_move_robot
    ld a, e_x(ix)
    ld b, e_y(ix)
    jr is_ia

store_first_mov:
    ld b, e_ma_x(ix)
    ld c, e_ma_y(ix)
    ld hl, #_matrix
    call input_store_mov_in_matrix

is_ia:

  
    ld a, e_num_mov(ix)
    inc a
    ld e_num_mov(ix), a


    
    pop af

    dec a
    ret z ;; Equals to JZ  

    ld bc, #sizeof_e
    add ix, bc
    jp _renloop


no_input_system_update:
    call input_pause
    ld a, #NOT_PAUSE
    ld ( #_pause_level), a
    jp input_system_update



ret