;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of AMSTRON: An Amstrad CPC Game 
;;  Copyright (C) 2019 - CPC Games 'La Yema' Francisco Luis Fernández Soriano
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables
 
.include "header.h.s"

;;
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;

.area _DATA

;; Define one Zero-terminated string to be used later on
;; string: .asciz "CPCtelera up and running!"
;;
;; Start of _CODE area
;; 

.area _CODE

;; 
;; Declare all function entry points as global symbols for the compiler.
;; (The linker will know what to do with them)
;; WARNING: Every global symbol declared will be linked, so DO NOT declare 
;; symbols for functions you do not use.

_pause_level:: .db #NOT_PAUSE

_game_mode:: .db #CARRERA_MODE

_arena:: .db #ARENA_1

_game_over:: .db #GAME_OVER

_uncontador: .db 6

_ia_robot:: .db #IA

_iterations: .db #0x00

_red_robot:: .db #0x00

_not_music:: .db #0x01

_array_sprites_player2:: 
                        .dw #_cmrh1
                        .dw #_cmrh2
                        .dw #_cmrh3
                        .dw #_cmrv1
                        .dw #_cmrv2
                        .dw #_cmrv3

_array_sprites_player1:: 
                        .dw #_cmvh1
                        .dw #_cmvh2
                        .dw #_cmvh3
                        .dw #_cmvv1
                        .dw #_cmvv2
                        .dw #_cmvv3

_matrix:: 
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF
  .db 0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF

_player2:: .db #0x48, #0xB0, #0x04, #0x4  ;; X Position , Y Position, Width Sprite in Bytes , Height Sprite in Bytes
       .dw #_mrl            ;; Sprite Bike 
       .db #MOTORBIKE_DIR_LEFT ;; Direction of the Bike
       .db #0x4C, #0xB0 ;; Previous X and Previous Y
       .db #IA ;; Player = Player2=2
       .db MOTORBIKE_NOT_CHANGE_DIRECTION
       .db NOTHING
       .db #MOTORBIKE_HORIZONTAL
       .db #0x00 ;; Ńum. Mov.
       .db #0x00 ;; _collision
       .db #0x00 ;; Animation 0
       .db #NO_RESET_PLAYER ;;  RESET 
       .db #0x0A ;; Lives    
       .db #MOTORBIKE_DIR_RIGHT ;; dir_ant
       .dw #_mvr ;; Sprite Ant
       .db #0x04 ;; e_w
       .db #0x04 ;; e_w
       .db #0x00 ;; e_extra_turn_right
       .db #0x00 ;; e_extra_turn_down
       
_player1:: .db #0x08, #0x30, #0x04, #0x4  ;; X Position , Y Position, Width Sprite in Bytes , Height Sprite in Bytes
       .dw #_mvr            ;; Sprite Bike 
       .db #MOTORBIKE_DIR_RIGHT ;; Direction of the Bike
       .db #0x04, #0x30 ;; Previous X and Previous Y
       .db #PLAYER1 ;; Player = Player1 = 1
       .db MOTORBIKE_NOT_CHANGE_DIRECTION
       .db NOTHING
       .db #MOTORBIKE_HORIZONTAL
       .db #0x00 ;; Ńum. Mov.
       .db #0x00 ;; _collision
       .db #0x00 ;; Animation 0
       .db #NO_RESET_PLAYER ;;  RESET 
       .db #0x0A ;; Lives    
       .db #MOTORBIKE_DIR_RIGHT ;; dir_ant
       .dw #_mvr ;; Sprite Ant
       .db #0x04 ;; e_w
       .db #0x04 ;; e_w
       .db #0x00 ;; e_extra_turn_right
       .db #0x00 ;; e_extra_turn_down

;;     PosX, PosY, velX, velY, wheelie, line, offset, speedRamp, turbo, empty,  Acc, timerRight,  timerY, poswheelie, player, sprite, rltv_pos, lock, vuelta, abs_pos, position, color

_obstacle:: .db #0x30, #0x60, #0x04, #0x10  ;; X Position , Y Position, Width Sprite in Bytes , Height Sprite in Bytes
       .dw #_robot            ;; Sprite Bike 
       .db #MOTORBIKE_DIR_LEFT ;; Direction of the Bike
       .db #0x30, #0x60 ;; Previous X and Previous Y
       .db #ROBOT ;; Player = Player1 = 1
       .db MOTORBIKE_NOT_CHANGE_DIRECTION
       .dw #_robot
       .db NOTHING
       .dw #0xDEAD
       .db #MOTORBIKE_HORIZONTAL
       .db #0x00 ;; Ńum. Mov.
       .db #0x00 ;; _collision
       .db #NO_EXTRA_WAKE
       .db #0x00 ;; Animation 0
       .db #NO_RESET_PLAYER ;;  RESET 
       .db #0x0A ;; Lives 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Function to Interrupt Handler
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

int_handler::

  push af
  push bc
  push de
  push hl

  ld a, ( #_uncontador )
  dec a
  jr nz, _cont

_guard:
  push af
  ld a, ( #_not_music )
  cp #0x01
  jr z,no_musica
  call cpct_akp_musicPlay_asm
  call cpct_scanKeyboard_if_asm
no_musica:
  pop af
  ld a, #6
_cont:
  ld ( #_uncontador ), a
  pop hl
  pop de
  pop bc
  pop af
  ei
reti

set_int_handler::

  call cpct_waitVSYNC_asm
  halt
  halt
  call cpct_waitVSYNC_asm

  ld hl, #0x38
  ld (hl), #0xC3
  inc hl
  ld (hl), #<int_handler
  inc hl
  ld (hl), #>int_handler
  ret
;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;

_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm
   cpctm_clearScreen_asm 0x00
   cpctm_setBorder_asm 0x14
   ld c, #1
   call cpct_setVideoMode_asm
   ld hl, #_g_palette
   ld de, #04
   call cpct_setPalette_asm
   call render_animation_carrera_mode_1
   ld c, #0
   call cpct_setVideoMode_asm
   ld hl, #_g_palette_2
   ld de, #16
   call cpct_setPalette_asm   
   ld hl, #_player1
   call entityman_create
   ld hl, #_player2
   call entityman_create
   ld hl, #_obstacle
   call entityman_create
   call set_int_handler

menu::
  ld  de, #_song_menu
  call cpct_akp_musicInit_asm
  ld c, #0
  call cpct_setVideoMode_asm
loop_menu:  
  call clearScreen
  ld a, #0x00
  ld ( #_not_music ), a
  call render_system_menu
  call input_system_menu
  ld a, ( #_game_over )
  cp #GAME_OVER
  jr z, loop_menu

  call input_system_init
  ;;call render_system_init
loop_game:
  call game_system_update
  ld a, ( #_game_over )
  cp #GAME_OVER
  jr z, menu
  jr loop_game
ret
  
clearScreen::
   cpctm_clearScreen_asm 0x00
   ;; ld    hl, #0xC000    
   ;; ld    de, #0xC001    ;; [3] DE Points to the next byte
   ;; ld    bc, #0x4000    ;; [3] BC = 16384 bytes to be copied
   ;; ldir               
ret

game_system_pause_1_sec::
    ld a, #50
loop_game_system_pause_1_sec::
  HALT
  dec a
  cp #0
  ret z
  jr nz, loop_game_system_pause_1_sec