;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of AMSTRON: An Amstrad CPC Game 
;;  Copyright (C) 2019 - CPC Games 'La Yema' Francisco Luis Fernández Soriano
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables
 
.include "header.h.s"
.include "entity_manager.h.s"

_player1_string: .asciz "PLAYER 1"
_player2_string: .asciz "PLAYER 2"
_title_string: .asciz "AMSTRON"
_arena1_string: .asciz " 1"
_arena2_string: .asciz " 2"
_arena3_string: .asciz " 3"
_arena4_string: .asciz " 4"
_arena5_string: .asciz " 5"
_arena6_string: .asciz " 6"
_arena7_string: .asciz " 7"
_arena8_string: .asciz " 8"
_arena9_string: .asciz " 9"
_arena_string: .asciz "ARENA"
_amstrad_string:   .asciz "AMSTRAD CPC 464@@@"  
_ams_string:   .asciz "WELCOME TO CPCTELERA FRAMEWORK@@@"  

_check_string:   .asciz "CHECKING SYSTEM@@@" 
_opqa_string: .asciz "ASSIGNING KEYS OPQA @@@" 

_ok_string:   .asciz "OK#" 

_Z80_string :   .asciz "Z80 4MHZ @@@" 
_sound_string :   .asciz "GENERAL INSTRUMENT AY 3 8910 @@@" 

_graphics_string :   .asciz "6845 CRTC @@@" 

_entertronow_string:   .asciz 'PRESS "L" TO LOAD &AMSTRON@BIN' 

_gameover_string: .asciz "GAME OVER"
_enter_string: .asciz 'PRESS "C" TO CONTINUE'
_thanks_string: .asciz "SPECIAL THANKS"
_run_string: .asciz "RUN AMSTRON@BIN"
_pocket_string: .asciz "&POCKET(LUCHO &FRANGALLEGOBR"

_nextlevel_string: .asciz "GO TO THE NEXT ARENA"
_pause_x_init: .db #0x0A
_pause_y_init: .db #0x50

_mode_carrera: .asciz "1@ MODE CARRERA"
_mode_versus: .asciz  "2@ VERSUS MODE"
_redefine_keys: .asciz  "3@ REDEFINE KEYS"
_credits: .asciz  "4@ CREDITS"
_victory: .asciz  "VICTORY"

_cpcretrodev_text: .asciz "CPC RETRODEV 2020"
_programming: .asciz  "PROGRAMMING BY &RONSONMARIA"
_graphics: .asciz  "GRAPHICS BY &DANYSNOWYMAN"
_music: .asciz  "MUSIC BY &PACOJMORAGARCIA"

_redefine_p1_left: .asciz  "P1 LEFT$  "
_redefine_p1_right: .asciz  "P1 RIGHT$ "
_redefine_p2_left: .asciz  "P2 LEFT$"
_redefine_p2_right: .asciz  "P2 RIGHT$"

_switch_arena_to_play: .asciz  'ENTER ARENA "1@@9"$'


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_animation_cursor  
;;    
;;  BC --> Screen position
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_animation_cursor:


    ld a, #0x03
    
    
loop_call_animation_cursor:
    cp #0
    ret z
   
    push af
    push de
    push bc
    ld de, #0xC000
    pop bc
    push bc
    call cpct_getScreenPtr_asm   
    ld c, #0x02
    ld b, #0x08
    pop bc
    pop de
    push de
    push bc
    ld c, #0x02
    ld b, #0x08
    ld a, d
    ex de, hl
    call cpct_drawSolidBox_asm

    call game_system_pause_1_sec
    call game_system_pause_1_sec
    

    ld de, #0xC000
    pop bc
    push bc
    call cpct_getScreenPtr_asm   
    ex de, hl
    ld c, #0x02
    ld b, #0x08

    ld a, #0x00
    call cpct_drawSolidBox_asm
    
    call game_system_pause_1_sec
    pop bc
    pop de
    pop af
    dec a
    jr loop_call_animation_cursor

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_animation_carrera_mode_1  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


render_animation_carrera_mode_1::

        
    ;;cpctm_clearScreen_asm
    ;;call render_sky_stars


    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld c, #0x00
    ld b, #0x05
    ld d, #0xF0
    call render_animation_cursor

    ld de, #0xC000
    ld iy, #_amstrad_string
    ld c, #0x00
    ld b, #0x05
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #36
    ld b, #0x05
    ld d, #0xF0
    call render_animation_cursor


    ld c, #0x00
    ld b, #0x10
    ld d, #0x0F
    call render_animation_cursor

    ld de, #0x0002
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_ams_string
    ld c, #0x00
    ld b, #0x10
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #66
    ld b, #0x10
    ld d, #0x0F
    call render_animation_cursor

    ld c, #0
    ld b, #0x20
    ld d, #0xFF
    call render_animation_cursor

    ld de, #0x0003
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_check_string
    ld c, #0x00
    ld b, #0x20
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01
  

    ld c, #36
    ld b, #0x20
    ld d, #0xFF
    call render_animation_cursor

    ld c, #00
    ld b, #0x30
    ld d, #0x0F
    call render_animation_cursor

    ld de, #0x0002
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_Z80_string
    ld c, #0x00
    ld b, #0x30
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_ok_string
    ld c, #0x17
    ld b, #0x30
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #29
    ld b, #0x30
    ld d, #0x0F
    call render_animation_cursor

     ld c, #00
    ld b, #0x40
    ld d, #0x0F
    call render_animation_cursor

    ld de, #0x0002
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_graphics_string
    ld c, #0x00
    ld b, #0x40
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_ok_string
    ld c, #0x19
    ld b, #0x40
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #31
    ld b, #0x40
    ld d, #0x0F
    call render_animation_cursor

    ld c, #00
    ld b, #0x50
    ld d, #0x0F
    call render_animation_cursor

    ld de, #0x0002
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_sound_string
    ld c, #0x00
    ld b, #0x50
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_ok_string
    ld c, #63
    ld b, #0x50
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #70
    ld b, #0x50
    ld d, #0x0F
    call render_animation_cursor

    ld c, #00
    ld b, #0x60
    ld d, #0x0F
    call render_animation_cursor

    ld de, #0x0002
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_opqa_string
    ld c, #0x00
    ld b, #0x60
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_ok_string
    ld c, #45
    ld b, #0x60
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #51
    ld b, #0x60
    ld d, #0x0F
    call render_animation_cursor

    ld c, #00
    ld b, #0x90
    ld d, #0xF0
    call render_animation_cursor

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_run_string
    ld c, #0x00
    ld b, #0x90
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld c, #30
    ld b, #0x90
    ld d, #0x0F
    call render_animation_cursor




ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_animation_motorbike_up  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_animation_motorbike_up:
    
    push af

    ld de, #0xC000
    ld b, #0x68
    ld c, #0x28
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x04 
    ld hl, #_lvh
    call cpct_drawSprite_asm

    pop af
    cp #MOTORBIKE_DIR_DOWN
    jr z, ajust_dir_down
    jr ajust_dir_up
ajust_dir_down:
    ld b, #0x68
    ld c, #0x2C
    ld a, #0x02
loop_render_animation_motorbike_down:
    cp #0x00
    ret z
    push af
    push bc
    ld de, #0xC000
    pop bc
    push bc
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x01
    ld b, #0x10 
    ld hl, #_lvv
    call cpct_drawSprite_asm

    ld de, #0xC000
    pop bc
    ld a, b
    add #0x10
    ld b, a
    push bc
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x01
    ld b, #0x10 
    ld hl, #_mvu
    call cpct_drawSprite_asm

    call game_system_pause_1_sec

    pop bc
    pop af
    dec a
    jr loop_render_animation_motorbike_down

    
ajust_dir_up:
    ld b, #0x5C
    ld c, #0x2C
    ld a, #0x02

loop_render_animation_motorbike_up:
    cp #0x00
    ret z
    push af
    push bc
    ld de, #0xC000
    pop bc
    push bc
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x01
    ld b, #0x10 
    ld hl, #_lvv
    call cpct_drawSprite_asm

    ld de, #0xC000
    pop bc
    ld a, b
    sub #0x10
    ld b, a
    push bc
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x01
    ld b, #0x10 
    ld hl, #_mvu
    call cpct_drawSprite_asm


    call game_system_pause_1_sec

    pop bc
    pop af
    dec a
    jr loop_render_animation_motorbike_up

ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_animation_motorbike  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_animation_motorbike:

    ld a, #0x09
    ld c, #0x04
    ld b, #0x68
loop_render_animation_motorbike:
    cp #0x00
    ret z
    push af
    push bc
    ld de, #0xC000
    pop bc
    push bc
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x04 
    ld hl, #_lvh
    call cpct_drawSprite_asm

    ld de, #0xC000
    pop bc
    inc c 
    inc c
    inc c
    inc c
    push bc
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x04 
    ld hl, #_mvr
    call cpct_drawSprite_asm

    call game_system_pause_1_sec

    pop bc
    pop af
    dec a
    jr loop_render_animation_motorbike




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;call_animation_cursor_right  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


call_animation_cursor_right:

    ld a, #0x03

loop_call_animation_cursor_right:
    cp #0
    ret z
    push af

    ld de, #0xC000
    ld c, #0x40
    ld b, #0x60
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x10
    ld a, #0x00
    call cpct_drawSolidBox_asm

    call game_system_pause_1_sec

    ld de, #0xC000
    ld c, #0x40
    ld b, #0x60
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x10
    ld hl, #_p1r
    call cpct_drawSprite_asm

    call game_system_pause_1_sec
    call game_system_pause_1_sec
    call game_system_pause_1_sec

    pop af
    dec a
    jr loop_call_animation_cursor_right

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;call_animation_cursor_left  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


call_animation_cursor_left:

    ld a, #0x03

loop_call_animation_cursor_left:
    cp #0
    ret z
    push af

    ld de, #0xC000
    ld c, #0x34
    ld b, #0x60
    call cpct_getScreenPtr_asm   
    ex de, hl
    ld c, #0x04
    ld b, #0x10
    ld a, #0x00
    call cpct_drawSolidBox_asm

    call game_system_pause_1_sec

    ld de, #0xC000
    ld c, #0x34
    ld b, #0x60
    call cpct_getScreenPtr_asm   
    ex de, hl
    ld c, #0x04
    ld b, #0x10
    ld hl, #_p1l
    call cpct_drawSprite_asm

    call game_system_pause_1_sec
    call game_system_pause_1_sec
    call game_system_pause_1_sec

    pop af
    dec a
    jr loop_call_animation_cursor_left

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_system_animation_begin  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_key_left_and_right:

 ld de, #0xC000
    ld c, #0x34
    ld b, #0x60
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x10 
    ld hl, #_p1l
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #0x40
    ld b, #0x60
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #0x04
    ld b, #0x10
    ld hl, #_p1r
    call cpct_drawSprite_asm

ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_sky_stars  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
render_sky_stars::

    ld bc, #0x1414
    ld de, #_level1_W
    ld hl, #_g_tileset_00
    call cpct_etm_setDrawTilemap4x8_ag_asm

    ld c, #0x00
    ld b, #0x28
    ld de, #0xC000
    call cpct_getScreenPtr_asm

    ld de, #_level4
    call cpct_etm_drawTilemap4x8_ag_asm
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  
;;
;;
;;render_system_animation_begin  
;;    
;;  
;; 
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_animation_begin::
    
    call clearScreen
    call render_sky_stars
    call render_key_left_and_right
    call render_animation_motorbike
    call call_animation_cursor_left
    ld a, #MOTORBIKE_DIR_UP
    call render_animation_motorbike_up
    call game_system_pause_1_sec
    call clearScreen
    call render_sky_stars
    call render_key_left_and_right
    call render_animation_motorbike
    call call_animation_cursor_right
    ld a, #MOTORBIKE_DIR_DOWN
    call render_animation_motorbike_up
    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ;;ld iy, #_entertronow_string
    ;;ld de, #0xC000
    ;;ld c, #0x04
    ;;ld b, #0xB0
    ;;call cpct_getScreenPtr_asm 
    ;;call _myDrawStringM01

ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 
;;  render_system_switch_arena
;;
;;  INPUT A --> KEY
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_switch_arena::
    call clearScreen
    call render_sky_stars
    ;;call render_system_top_menu

    ld de, #0x0001
    call cpct_setDrawCharM1_asm
    ld de, #0xC000
    ld c, #0x10
    ld b, #0x60
    ld iy, #_switch_arena_to_play
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01
ret


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 
;;  render_system_redefine_keys
;;
;;  INPUT A --> KEY
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_redefine_keys::

    cp #P1_LEFT
    jr z, text_p1_left
    cp #P1_RIGHT
    jr z, text_p1_right
    cp #P2_RIGHT
    jr z, text_p2_left
    ld iy, #_redefine_p2_right
    jr continue_render_system_redefine_keys

text_p1_left:
    ld iy, #_redefine_p1_left
    jr continue_render_system_redefine_keys
text_p1_right:
    ld iy, #_redefine_p1_right
    jr continue_render_system_redefine_keys
text_p2_left:
    ld iy, #_redefine_p2_left
    jr continue_render_system_redefine_keys



continue_render_system_redefine_keys:

    ;;call render_system_top_menu
    
    ld de, #0x0001
    call cpct_setDrawCharM1_asm
    
    ld de, #0xC000
 
    ld c, #0x10
    ld b, #0x60
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

ret




    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 
;;  render_system_top_menu
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_top_menu::

    ld de, #0xC000
    ld c, #0x10
    ld b, #0x0A
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #50
    ld b, #50 
    ld hl, #_amstronmenu
    call cpct_drawSprite_asm

     ld de, #0xC000
    ld c, #13
    ld b, #161 
    ld hl, #_izquierdamenu
    call cpct_drawSprite_asm

    

    ld de, #0xC000
    ld c, #0x00
    ld b, #160
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #42
    ld b, #40 
    ld hl, #_abajoizquierdamenu
    call cpct_drawSprite_asm

    
    
      ld de, #0xC000
    ld c, #0x2A
    ld b, #160
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #38
    ld b, #40 
    ld hl, #_abajoderechamenu
    call cpct_drawSprite_asm


    ld de, #0xC000
    ld c, #0x43
    ld b, #0x00
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #13
    ld b, #160 
    ld hl, #_derechamenu
    call cpct_drawSprite_asm

     ;;ld de, #0xC000
   ;;ld c, #0x20
   ;;ld b, #0x28
   ;;call cpct_getScreenPtr_asm  
    ;;ex de, hl
    ;;ld c, #0x10
    ;;ld b, #0x20 
    ;;ld hl, #_tn
    ;;call cpct_drawSprite_asm

    ;;ld de, #0xC000
    ;;ld c, #0x18
    ;;ld b, #0x20
    ;;call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)
    
    ;;ex de, hl
    ;;ld c, #0x05
    ;;ld b, #0x25 
    ;;ld hl, #_cv
    ;;call cpct_drawSprite_asm


   ;; ld de, #0xC000
   ;; ld c, #0x32
   ;; ld b, #0x20
    ;;call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)
    
   ;; ex de, hl
   ;; ld c, #0x05
   ;; ld b, #0x25 
    ;;ld hl, #_cr
   ;; call cpct_drawSprite_asm
   


ret

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 
;;  render_system_menu_text
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_menu_text:

    ld de, #0xC000
    ld c, #0x15
    ld b, #0x4A
    call cpct_getScreenPtr_asm  
    ex de, hl
    ld c, #37
    ld b, #57 
    ld hl, #_letras
    call cpct_drawSprite_asm

    ;;ld de, #0x0001
    ;;ld hl, #0x0006
   ;; call cpct_setDrawCharM0_asm

    
    ;;ld de, #0xC000
    ;;ld iy, #_mode_carrera
    ;;ld c, #0x0A
    ;;ld b, #0x60
    ;;call cpct_getScreenPtr_asm 
    ;;call cpct_drawStringM0_asm
   
    ;;ld iy, #_mode_versus
    ;;ld de, #0xC000
    ;;ld c, #0x0A
    ;;ld b, #0x70
    ;;call cpct_getScreenPtr_asm 
   ;;call cpct_drawStringM0_asm

    ;;ld iy, #_redefine_keys
    ;;ld de, #0xC000
    ;;ld c, #0x1A
    ;:;ld b, #0x80
    ;;call cpct_getScreenPtr_asm 
   ;;call cpct_drawStringM0_asm

    ;;ld iy, #_credits
    ;;ld de, #0xC000
    ;;ld c, #0x1A
    ;;ld b, #0x90
    ;;call cpct_getScreenPtr_asm 
    ;;call _myDrawStringM00
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; render_system_menu
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_credit_screen::

 

    call clearScreen

    call render_sky_stars
  
    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_title_string
    ld c, #35
    ld b, #0x10
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0002
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_cpcretrodev_text
    ld c, #25
    ld b, #0x20
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld de, #0xC000
    ld iy, #_music
    ld c, #0x10
    ld b, #0x30
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld iy, #_graphics
    ld de, #0xC000
    ld c, #0x10
    ld b, #0x40
    call cpct_getScreenPtr_asm 
   call _myDrawStringM01

    ld iy, #_programming
    ld de, #0xC000
    ld c, #0x10
    ld b, #0x50
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0003
    call cpct_setDrawCharM1_asm
    ld de, #0xC000
    ld iy, #_thanks_string
    ld c, #29
    ld b, #0x60
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

    ld de, #0x0002
    call cpct_setDrawCharM1_asm
    ld de, #0xC000
    ld iy, #_pocket_string
    ld c, #0x10
    ld b, #0x70
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01

           ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)
    

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld iy, #_enter_string
    ld de, #0xC000
    ld c, #0x17
    ld b, #0x90
    call cpct_getScreenPtr_asm 
    call _myDrawStringM01
    
    

loop_render_system_credit_screen:

    
    
    ; scan the whole keyboard
    call cpct_scanKeyboard_asm
    ;; If no key is pressed, the address is read and incremented
    ld hl, #Key_C
    call cpct_isKeyPressed_asm
    cp #0
    jr nz,  exit_loop_render_system_credit_screen
    jr loop_render_system_credit_screen

exit_loop_render_system_credit_screen:

    call cpct_akp_stop_asm
    ld c, #0
    call cpct_setVideoMode_asm
    ld hl, #_g_palette_2
   ld de, #16
   call cpct_setPalette_asm  
   call render_system_menu

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; render_system_menu
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_menu:

   
    ;;call render_sky_stars
    call render_system_top_menu
    call render_system_menu_text

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; render_system_draw_arena
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_draw_arena:

    ld bc, #0x1414
    ld de, #_level1_W
    ld hl, #_g_tileset_00
    call cpct_etm_setDrawTilemap4x8_ag_asm

    ld c, #0x00
    ld b, #0x28
    ld de, #0xC000
    call cpct_getScreenPtr_asm

    ld a, ( #_arena )
    cp #ARENA_1
    jr z, render_system_draw_arena_1
    cp #ARENA_2
    jr z, render_system_draw_arena_2
    cp #ARENA_3
    jr z, render_system_draw_arena_3
    cp #ARENA_4
    jr z, render_system_draw_arena_4
    cp #ARENA_5
    jr z, render_system_draw_arena_5
    cp #ARENA_6
    jr z, render_system_draw_arena_6
    cp #ARENA_7
    jr z, render_system_draw_arena_1
    cp #ARENA_8
    jr z, render_system_draw_arena_4
     cp #ARENA_9
    jr z, render_system_draw_arena_6

render_system_draw_arena_7:
    ld de, #_level1
    jr draw_arena

render_system_draw_arena_1:
    ld de, #_level1
    jr draw_arena

render_system_draw_arena_2:

    ld de, #_level2
    jr draw_arena

render_system_draw_arena_3:

    ld de, #_level3
    jr draw_arena

render_system_draw_arena_4:
    ld de, #_level1
    call cpct_etm_drawTilemap4x8_ag_asm 
    jr  continue_black_hole

render_system_draw_arena_5:
    ld de, #_level2
    call cpct_etm_drawTilemap4x8_ag_asm 
    jr  continue_black_hole

render_system_draw_arena_6:
    ld de, #_level3
    call cpct_etm_drawTilemap4x8_ag_asm 
    jr  continue_black_hole


continue_black_hole:

    ld a, #0x03
    ld iy, #_arena3_string
    push af
loop_draw_arena_4:

    ld de, #0xC000
    ld c, #0x0024
    ld b, #0x006F
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

    ld a, #240
pausa_arena_4:
    dec a
    cp #0
    HALT
    jp nz, pausa_arena_4

    
    pop af
    dec a
    cp #2
    jp z, arena4_text_2
    cp #1
    jp z, arena4_text_1 
    cp #0
    jp z, end_of_arena4

arena4_text_2:
    ld iy, #_arena2_string
    push af
    jp loop_draw_arena_4

arena4_text_1:
    ld iy, #_arena1_string
    push af
    jp loop_draw_arena_4

end_of_arena4:
    call clearScreen
    ld c, #0x00
    ld b, #0x28
    ld de, #0xC000
    call cpct_getScreenPtr_asm
    ld de, #_level4
    jr draw_arena

draw_arena:
    call cpct_etm_drawTilemap4x8_ag_asm  

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  render_system_player_victory
;;  
;;  
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
render_system_player_victory:
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, render_player2_victory
    ld hl, #_trofeo_p1
    ld de, #0x0002
    push de
    jr render_text_victory

render_player2_victory:
    ld hl, #_trofeo_p2
    ld de, #0x0003
    push de
     
render_text_victory:    
    push hl 
    ld de, #0xC000
    ld c, #0x18
    ld b, #0x5B
    call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)

    ld b, #0x10                 ;; Height of the Drawable Entity
    ld c, #0x04               ;; Width of the Drawable Entity
    ex de, hl                   ;; DE = Pointer of the screen to the up left corner of our entity
    pop hl
    call cpct_drawSprite_asm

    pop de
    call cpct_setDrawCharM1_asm

    ld iy, #_victory
    ld de, #0xC000
    ld c, #0x22
    ld b, #0x60
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01


ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  render_rectangle_pause
;;  
;;  
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_game_over::
    ld a, ( _game_mode )
    cp #CARRERA_MODE
    jr z, carrera_mode_render_game_over
    





carrera_mode_render_game_over:
   
    call render_system_player_victory
    ld de, #0x0003
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, green_game_over
    jr continue_carrera_mode_render_game_over
green_game_over:
    ld de, #0x0002
continue_carrera_mode_render_game_over:
    call cpct_setDrawCharM1_asm
    ld iy, #_gameover_string
    ld de, #0xC000
    ld c, #0x20
    ld b, #0x76
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01
    ld de, #0x0001
    call cpct_setDrawCharM1_asm
    ld iy, #_enter_string
    ld de, #0xC000
    ld c, #0x12
    ld b, #0x91
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01


ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  render_rectangle_pause
;;  
;;  
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_next_level::
   
    
    ld de, #0xC000
    ld c, #0x25            
    ld b, #0x60                 
    call cpct_getScreenPtr_asm          

    ld b, #0x10                 
    ld c, #0x04              
    ex de, hl                  
    ld hl, #_robot
    call cpct_drawSprite_asm


    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld iy, #_nextlevel_string
    ld de, #0xC000
    ld c, #0x14
    ld b, #0x7A
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01
    ld iy, #_enter_string
    ld de, #0xC000
    ld c, #0x14
    ld b, #0x91
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  render_rectangle_pause
;;  
;;  
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_rectangle_pause::

    ld a, #0xF0
    push af
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, change_color_green_rectangle
    jr continue_render_rectangle_pause

change_color_green_rectangle:
    pop af
    ld a, #0xF0
    push af
continue_render_rectangle_pause:
    ;; Draw The Entity 
    ld a, (#_pause_x_init)
    ld c, a
    ld a, (#_pause_y_init) 
    ld b, a 
    ld de, #0xC000
    call cpct_getScreenPtr_asm 

    ex de, hl
    pop af
    ld c, #0x3D
    ld b, #0x61 
    call cpct_drawSolidBox_asm

    ;; Draw The Entity 
    ld a, (#_pause_x_init)
    ld c, a
    inc c
    ld a, (#_pause_y_init) 
    add #04
    ld b, a 
    
    ld de, #0xC000
    call cpct_getScreenPtr_asm  

    ex de, hl
    ld a, #0x00
    ld c, #0x3B
    ld b, #0x59
    call cpct_drawSolidBox_asm 

     



ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_score_update
;;  
;; 
;; 
;; 
;; 
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
render_score_update::

    cp #0
    jr z, end_render_score_update

    ld d, #0x00
    ld e, #0x00
    
    push af

    ld a, e_player(ix)
    cp #PLAYER1
    jr z, player1_x_y
    ld c, #0x4A
    ld b, #0x17
    ld d, c
    push de
    jr bucle_render_lives

   player1_x_y:
   
     ld c, #0x04
     ld b, #0x17
     ld d, c
     push de
    


bucle_render_lives:
    ;; Draw The Entity 
    ld de, #0xC000
    call cpct_getScreenPtr_asm  

    ex de, hl
    ld a, #0x00
    ld c, #0x02
    ld b, #0x0F 
    call cpct_drawSolidBox_asm 

    pop de
    pop af

    dec a 
    cp #0
    jr z, end_render_score_update

    push af
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, p1_increase_render_score_update
    dec d
    dec d
    jr begin_render_score_update

p1_increase_render_score_update:
    inc d
    inc d

begin_render_score_update:
    push de
    ld c, d
    ld b, #0x17
    jr bucle_render_lives  


end_render_score_update:

ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_collision
;;  
;; 
;; C --> X coordenade
;; B --> Y coordenade
;; 
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
render_system_collision:
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, render_collision_player1
    ld hl, #_array_sprites_player2
    jr render_system_collision_continous
render_collision_player1: 
    ld hl, #_array_sprites_player1
render_system_collision_continous:
    ld a, e_anim(ix)
    ld d, #0x00
    ld e, a
    add hl, de
    push hl
    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_RIGHT
    jr z, not_use_x_and_y
    ld hl, #_matrix
    ld b, e_x(ix)
    ld c, e_y(ix) 
    call input_get_position_in_matrix
    ld b, e_player(ix)
    ld a, (hl)
    cp b
    jr z, use_x_and_y
not_use_x_and_y:
    ld c, e_ma_x(ix)
    ld b, e_ma_y(ix)
    jr continue_draw_collision 
use_x_and_y:
    ld c, e_x(ix)
    ld b, e_y(ix) 
continue_draw_collision:
    ;; Draw The Entity 
    ld de, #0xC000 

                    ;; C = Entity Y 
    call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)
    ex de, hl
    ld b, e_h_ant(ix)                
    ld c, e_w_ant(ix)               
    pop hl     
    push de
    ld e, (hl)
    inc hl
    ld d, (hl)
    ex de, hl
    pop de
    call cpct_drawSprite_asm  
ret

    
      
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_score_init
;;  
;; INPUT --> HL Sprite to Draw
;; C --> X coordenade
;; B --> Y coordenade
;; D --> HEIGTHT in Bytes
;; E -> WIDTH in Bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
render_score_init::
  ;; Draw the score 
    push hl
    push de
    ld de, #0xC000
    call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)
    pop de
    ld b, d                 ;; Height of the Drawable Entity
    ld c, e               ;; Width of the Drawable Entity
    ex de, hl
    pop hl                   ;; DE = Pointer of the screen to the up left corner of our entity
    call cpct_drawSprite_asm

ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_init
;;  Se ejecuta una sola vez al principio de la ejecucion
;;  para inicializar cosas relativas al render
;;
;; MODIFIES: HL, DE, BC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
render_system_init::
  
    call clearScreen
    call collision_clean_all_matrix
    ld a, ( #_arena )
    call render_system_draw_arena
    ld a, ( #_arena )
    call collision_system_init_matrix_by_arena
    


    ;; Render The Score Region
    ;; C --> X coordenade
    ;; B --> Y coordenade
    ;; D --> HEIGTHT in Bytes
    ;; E -> WIDTH in Bytes
    ;; Green Score
    ld a, #0x0A-#NUM_LIVES
    push af 
    ld b, #0x4A
    push bc
    ld b, #0x04
    push bc
  render_energy:
    ld c, b
    ld b, #0x16
    ld e, #0x02
    ld d, #0x10
    ld hl, #_ev
    call render_score_init
    pop bc
    ld a,#0x02
    add b
    ld d,a
    pop bc
    ld c, b

    dec b
    dec b
    push bc
    ld b,d
    push bc
    ld b, #0x16
    ld e, #0x02
    ld d, #0x10
    ld hl, #_er
    call render_score_init
    pop bc
    ld d,b
    pop bc
    pop af
    dec a
    push af
    push bc
    ld b,d
    push bc
    jp nz, render_energy
    pop bc
    pop bc
    pop af
    
    ;; Green MotorBike Score
    ld c, #0x16
    ld b, #0x14
    ld e, #0x06
    ld d, #0x14
    ld hl, #_mvs
    call render_score_init

;;    ld c, #0x1C
  ;;  ld b, #0x04
    ;; ld e, #0x05
   ;; ld d, #0x25 
  ;;  ld hl, #_cv
   ;; call render_score_init

    ;; Red MotorBike Score
    ld c, #0x32
    ld b, #0x14
    ld e, #0x06
    ld d, #0x14
    ld hl, #_mrs
    call render_score_init
    

    ;;ld c, #0x2D
    ;;ld b, #0x04
    ;;ld e, #0x05
    ;;ld d, #0x25 
    ;;::ld hl, #_cr
    ;;call render_score_init

render_text_player:


    ld de, #0x0002
    call cpct_setDrawCharM1_asm


    ld iy, #_player1_string
    ld de, #0xC000
    ld c, #0x0006
    ld b, #0x000A
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

    ld de, #0x0003
    call cpct_setDrawCharM1_asm


    ld iy, #_player2_string
    ld de, #0xC000
    ld c, #0x0038
    ld b, #0x000A
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm
    ld iy, #_title_string
    ld de, #0xC000
    ld c, #0x0020
    ld b, #0x0014
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

    ld de, #0x0001
    call cpct_setDrawCharM1_asm

    ld iy, #_arena_string
    ld de, #0xC000
    ld c, #0x0020
    ld b, #0x001F
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

    ld a, ( #_arena )
    cp #ARENA_1
    jr z, arena1_text
    cp #ARENA_2
    jr z, arena2_text
    cp #ARENA_3
    jr z, arena3_text
    cp #ARENA_4
    jr z, arena4_text
    cp #ARENA_5
    jr z, arena5_text
    cp #ARENA_6
    jr z, arena6_text
    cp #ARENA_7
    jr z, arena7_text
    cp #ARENA_8
    jr z, arena8_text
    cp #ARENA_9
    jr z, arena9_text
arena1_text:  
    ld iy, #_arena1_string
    jr continue_arena_text
arena2_text:  
    ld iy, #_arena2_string
    jr continue_arena_text
arena3_text:  
    ld iy, #_arena3_string
    jr continue_arena_text
arena4_text:  
    ld iy, #_arena4_string
    jr continue_arena_text
arena5_text:  
    ld iy, #_arena5_string
    jr continue_arena_text
arena6_text:  
    ld iy, #_arena6_string
    jr continue_arena_text
arena7_text:  
    ld iy, #_arena7_string
    jr continue_arena_text
arena8_text:  
    ld iy, #_arena8_string
    jr continue_arena_text
arena9_text:  
    ld iy, #_arena9_string
    jr continue_arena_text

continue_arena_text:
    ld de, #0xC000
    ld c, #0x002A
    ld b, #0x001F
    call cpct_getScreenPtr_asm  
    call _myDrawStringM01

    
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;;  
;; render_system_clean_robot
;;  
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_clean_robot:

    ld de, #0xC000
    ld c, e_ma_x(ix)
    ld b, e_ma_y(ix)
    push bc
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_g_tileset_01
    call cpct_drawTileGrayCode4x8_af_asm


    ld de, #0xC000
    pop bc
    ld a, b
    add #0x08
    ld b, a
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_g_tileset_01
    call cpct_drawTileGrayCode4x8_af_asm


    ld b, e_player(ix)
   ;;call collision_clean_matrix_by_player
    
ret 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;;  
;; render_system_robot
;;  
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_robot:  

    ld de, #0xC000
    ld c, e_x(ix)                 ;; B = Entity X
    ld b, e_y(ix)                 ;; C = Entity Y 
    call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)

    ld b, e_h(ix)                 ;; Height of the Drawable Entity
    ld c, e_w(ix)               ;; Width of the Drawable Entity
    ex de, hl  
    ld hl, #_robot
    call cpct_drawSprite_asm

    
ret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_calculate_tile_to_erase_by_dir
;;  
;; A <-- DIR
;;  
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_calculate_tile_to_erase_by_dir:
    cp #MOTORBIKE_DIR_RIGHT
    jr z, rsc_hl_tile_lr
    cp #MOTORBIKE_DIR_LEFT
    jr z, rsc_hl_tile_lr
    cp #MOTORBIKE_DIR_DOWN
    jr z, rsc_hl_tile_ud
    cp #MOTORBIKE_DIR_UP
    jr z, rsc_hl_tile_ud
rsc_hl_tile_lr:
    ld hl, #_g_tileset_30
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, assign_tileset_player_1_lr
ret
assign_tileset_player_1_lr:
    ld hl, #_g_tileset_25 
ret
rsc_hl_tile_ud:
    ld hl, #_g_tileset_28
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, assign_tileset_player_1_ud
ret
assign_tileset_player_1_ud:
    ld hl, #_g_tileset_23
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_draw_tile
;;  
;; HL <<- TILE TO DRAW
;; 
;;  C  <<-- X
;;  B  <<-- Y
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_draw_tile_by_tile:
    push hl
    ld de, #0xC000
    call cpct_getScreenPtr_asm
    ex de, hl
    pop hl
    call cpct_drawTileGrayCode4x8_af_asm
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_end_erase_entity
;;  
;; A <<-- DIR 
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_end_erase_entity:
    push af

    ld a, e_extra_turn_down(ix)
    cp #0x01
    jr z, reset_extra_turn_down
    jr continue_evalue_turn_right
reset_extra_turn_down:
    ld a, #0x00
    ld e_extra_turn_down(ix), a
    jr reset_extra_turn_right
continue_evalue_turn_right:
    ld a, e_extra_turn_right(ix)
    cp #0x01
    jr z, reset_extra_turn_right
    jr continue_end_render_system_erase_entity
reset_extra_turn_right:
    ld a, #0x00
    ld e_extra_turn_right(ix), a
    ld c, e_ma_x(ix)
    ld b, e_ma_y(ix)
    ld hl, #_g_tileset_31
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, assign_tile8_player_1
    jr continue_render_system_draw_tile_by_tile_1
assign_tile8_player_1:
    ld hl, #_g_tileset_08
continue_render_system_draw_tile_by_tile_1:
    call render_system_draw_tile_by_tile
    pop af
    cp #MOTORBIKE_DIR_DOWN
    jr z, repeat_draw_tile_down
     cp #MOTORBIKE_DIR_UP
    jr z, repeat_draw_tile_down
ret
continue_end_render_system_erase_entity:
    ld c, e_ma_x(ix)
    ld b, e_ma_y(ix)
    pop af
    push af
    call render_system_calculate_tile_to_erase_by_dir
    call render_system_draw_tile_by_tile
    pop af
    cp #MOTORBIKE_DIR_DOWN
    jr z, repeat_draw_tile_down
     cp #MOTORBIKE_DIR_UP
    jr z, repeat_draw_tile_down
ret
repeat_draw_tile_down:
    push af
    ld c, e_ma_x(ix)
    ld b, e_ma_y(ix)
    ld a, b
    add #0x08
    ld b, a
    pop af
    call render_system_calculate_tile_to_erase_by_dir
    call render_system_draw_tile_by_tile

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_updfate
;;  
;; IX: Pointer to first entity to render
;;  A: Number of entities to render
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_erase_entity::

    ld a, e_dir(ix)
    ld b, e_dir_ant(ix)
    cp b
    jp z, call_render_system_end_erase_entity


    ld a, e_dir(ix)
    cp #MOTORBIKE_DIR_RIGHT
    jr z, end_render_system_erase_turn_right
    cp #MOTORBIKE_DIR_LEFT
    jr z, end_render_system_erase_turn_left
    cp #MOTORBIKE_DIR_DOWN
    jr z, end_render_system_erase_turn_down
    cp #MOTORBIKE_DIR_UP
    jr z, end_render_system_erase_turn_up

end_render_system_erase_turn_up:
    ld a, e_dir_ant(ix)
    cp #MOTORBIKE_DIR_LEFT
    jp z, end_render_system_erase_entity_change_dir
    ld c, e_ma_x(ix)
    ld a, c
    add #0x04
    ld c, a
    ld b, e_ma_y(ix)
    ld hl, #_g_tileset_26
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, assign_tile21_player_1_turn_up
    jr continue_end_render_system_erase_turn_up

assign_tile21_player_1_turn_up:
    ld hl, #_g_tileset_21
continue_end_render_system_erase_turn_up:
    call render_system_draw_tile_by_tile
    jp end_render_system_erase_entity_change_dir

ret
end_render_system_erase_turn_left:
    ld a, e_dir_ant(ix)
    cp #MOTORBIKE_DIR_UP
    jp z, end_render_system_erase_entity_change_dir
    ld c, e_x(ix)
    ld a, c
    add #0x04
    ld c, a
    ld b, e_y(ix)
    ld hl, #_g_tileset_26
    ld a, e_player(ix)
    cp #PLAYER1
    jr z, assign_tile21_player_1
    jr continue_render_system_draw_tile_by_tile
assign_tile21_player_1:
    ld hl, #_g_tileset_21
continue_render_system_draw_tile_by_tile:
    call render_system_draw_tile_by_tile
    jp end_render_system_erase_entity_change_dir
ret

end_render_system_erase_turn_right:
    ld a, e_dir_ant(ix)
    cp #MOTORBIKE_DIR_UP
    jr z, change_extra_turn_right
    jp end_render_system_erase_entity_change_dir
change_extra_turn_right:
    ld a, #0x01
    ld e_extra_turn_right(ix) , a

    ld c, e_ma_x(ix)
    ld b, e_ma_y(ix)
    ld a, b
    add #0x08
    ld b, a
    ld a, e_dir_ant(ix)
    call render_system_calculate_tile_to_erase_by_dir
    call render_system_draw_tile_by_tile
ret

end_render_system_erase_turn_down:
    ld a, e_dir_ant(ix)
    cp #MOTORBIKE_DIR_LEFT
    jr z, call_extra_turn_down
    jp end_render_system_erase_entity_change_dir
call_extra_turn_down:
    ld a, #0x01
    ld e_extra_turn_down(ix), a
ret
call_render_system_end_erase_entity:
    ld a, e_dir(ix)
    call render_system_end_erase_entity
ret

end_render_system_erase_entity_change_dir:
    ld a, e_dir_ant(ix)
    call render_system_end_erase_entity
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_entity
;;  
;; IX: Pointer to first entity to render
;;  A: Number of entities to render
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_entity:

    ;; Draw The Entity 
    ld de, #0xC000
    ld c, e_x(ix)                 ;; B = Entity X
    ld b, e_y(ix)                 ;; C = Entity Y 
    call cpct_getScreenPtr_asm          ;; Gets on HL the pointer to x,y position on Hx(Hexadecimal)

    ld b, e_h(ix)                 ;; Height of the Drawable Entity
    ld c, e_w(ix)               ;; Width of the Drawable Entity
    ex de, hl                   ;; DE = Pointer of the screen to the up left corner of our entity
    ld h, e_sp_h(ix)
    ld l, e_sp_l(ix)
    call cpct_drawSprite_asm
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; render_system_update
;;  
;; IX: Pointer to first entity to render
;;  A: Number of entities to render
;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

render_system_update::

    ld a, ( #_pause_level )
    cp #PAUSE
    jp z, no_render_system

    call entityman_getEntityArray_IX
    call entityman_getNumEntities_A

_renloop:
    push af
    ld a, e_player(ix)
    cp #ROBOT
    jr z, check_if_draw_robot
    jr continue_render_system_update

check_if_draw_robot:
    ld a, ( #_red_robot )
    cp #0x00
    jr z, next_loop
    jr continue_render_robot
continue_render_system_update:

    ld a, e_collision(ix)
    cp #1
    jp z, call_render_system_collision
    call render_system_erase_entity
    call render_system_entity
    jr next_loop
    
call_render_system_collision:
   call render_system_collision
   jr next_loop

continue_render_robot:
   ;; call render_system_clean_robot
    call render_system_entity
    
next_loop:




    ld e_changedir(ix), #MOTORBIKE_NOT_CHANGE_DIRECTION
    pop af

    dec a
    ret z ;; Equals to JZ  

    ld bc, #sizeof_e
    add ix, bc
    jp _renloop

no_render_system:
    
ret





